Imports System.Windows.Forms.MessageBox

Public Class frmMain
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        End
    End Sub

    Private Sub mnuHelpAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHelpAbout.Click
        frmHelp.ShowDialog()
    End Sub

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        processDNS(0)
    End Sub

    Private Sub processDNS(ByVal retryCount As Integer)
        If retryCount > 5 Then
            MsgBox("There was an error while getting the list of support computers. Please advise the support technician of this error.", MsgBoxStyle.Critical, "Error connecting to the internet")
            End
        Else
            Dim dnsList As String = dhReq(My.Settings.apiUser, My.Settings.apiKey, "dns-list_records")
            Dim dnsArray As String() = dnsList.Split(vbLf)
            If dnsArray(0) = "error" Then
                processDNS(retryCount + 1)
                Exit Sub
            Else
                dnsArray(0) = ""
                dnsArray(1) = ""
                Dim hostKeyword As String = "Support:"
                Dim dnsRecordInfo As String()
                For Each dnsRecord As String In dnsArray
                    If dnsRecord <> "" Then
                        dnsRecordInfo = dnsRecord.Split(vbTab)
                        If dnsRecordInfo(5) <> "" Then
                            If dnsRecordInfo(5).Substring(0, hostKeyword.Length) = hostKeyword Then
                                Dim supportServer As New SupportServer
                                If dnsRecordInfo(5).Contains("|") Then
                                    Dim fullHost As String = dnsRecordInfo(5).Substring(hostKeyword.Length)
                                    supportServer.name = fullHost.Split("|")(0)
                                    supportServer.port = fullHost.Split("|")(1)
                                Else
                                    supportServer.name = dnsRecordInfo(5).Substring(hostKeyword.Length)
                                End If
                                supportServer.host = dnsRecordInfo(2)

                                Me.lstSupportServers.Items.Add(supportServer)
                            End If
                        End If
                    End If
                Next
            End If
        End If
    End Sub

    Private Function dhReq(ByVal user As String, ByVal apikey As String, ByVal cmd As String) As String
        Dim uniqueId As String
        uniqueId = System.Guid.NewGuid.ToString()


        Dim apiUrl As String
        apiUrl = "https://api.dreamhost.com/"
        apiUrl &= "?username=" & System.Web.HttpUtility.UrlEncode(user)
        apiUrl &= "&key=" & apikey
        apiUrl &= "&cmd=" & cmd
        apiUrl &= "&unique_id=" & uniqueId

        Dim httpReq As New WinHttp.WinHttpRequest
        httpReq.Open("GET", apiUrl, False)
        httpReq.Send()

        If httpReq.Status = 401 Then
            Return "error" & vbLf & "401"
        Else
            Return httpReq.ResponseText
        End If
    End Function

    Private Sub initiateConnection()
        If Me.lstSupportServers.SelectedIndex <> -1 Then
            Dim selectedSupportServer As SupportServer
            selectedSupportServer = Me.lstSupportServers.Items(Me.lstSupportServers.SelectedIndex)

            Dim appPath As String = System.Windows.Forms.Application.StartupPath
            Me.Hide()
            Dim params As String
            If selectedSupportServer.port = "5500" Then
                params = "-connect " & selectedSupportServer.host
            Else
                params = "-connect " & selectedSupportServer.host & "::" & selectedSupportServer.port
            End If
            Shell(appPath & "\vnc\winvnc.exe " & params, AppWinStyle.NormalFocus, True)
            MsgBox("Support Session has been terminated.", MsgBoxStyle.Information, "Support Ended")
            End
        Else
            MsgBox("No server selected!", MsgBoxStyle.Critical)
        End If
    End Sub

    Private Sub cmdConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdConnect.Click
        initiateConnection()
    End Sub

    Private Sub lstSupportServers_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstSupportServers.MouseDoubleClick
        initiateConnection()
    End Sub
End Class